#include "perpetualServo.h"
#include "EEPROM.h"

	int _motor1;
	int _motor2;
	int _analogX;
	int _analogY;

PerpetualServo::PerpetualServo()
{
	
}

void PerpetualServo::begin(int motor1, int motor2, int analogX, int analogY)
{
	_motor1=motor1;
	_motor2=motor2;
	_analogX=analogX;
	_analogY=analogY;
	pinMode(_motor1, OUTPUT);
	pinMode(_motor2, OUTPUT);
}

void PerpetualServo::calibrate()
{
	unsigned long startTime=millis();
	
	int xMax=712;
	int xMin=312;
	int yMax=712;
	int yMin=312;
	
	
	while((millis()-startTime)<4000)
	{
		digitalWrite(_motor1, HIGH);
		digitalWrite(_motor2, LOW);
		
		int xTemp=analogRead(_analogX);
		int yTemp=analogRead(_analogY);
		
		if(xTemp>xMax)
		{
			xMax=xTemp;
		}
		if(xTemp<xMin)
		{
			xMin=xTemp;
		}
		if(yTemp>yMax)
		{
			yMax=yTemp;
		}
		if(yTemp<yMin)
		{
			yMin=yTemp;
		}
	}
	
	digitalWrite(_motor1, LOW);
	
	EEPROM.put(0, xMax);
	EEPROM.put(2, xMin);
	EEPROM.put(4, yMax);
	EEPROM.put(6, yMin);
}


/*float PerpetualServo::getX()
{
	int xMax;
	int xMin;
	
	EEPROM.get(0, xMax);
	EEPROM.get(2, xMin);

	float xComp=(float)map(analogRead(_analogX), xMin, xMax, -512.0, +512.0);
	return xComp;
}

float PerpetualServo::getY()
{
	int yMax;
	int yMin;
	
	EEPROM.get(4, yMax);
	EEPROM.get(6, yMin);

	float yComp=(float)map(analogRead(_analogY), yMin, yMax, -512.0, +512.0);
	return yComp;
}*/

int PerpetualServo::getAngle()
{
	int xMax;
	int xMin;
	int yMax;
	int yMin;
	
	EEPROM.get(0, xMax);
	EEPROM.get(2, xMin);
	EEPROM.get(4, yMax);
	EEPROM.get(6, yMin); 
	
	float xComp=(float)map(analogRead(_analogX), xMin, xMax, -512.0, +512.0);
	float yComp=(float)map(analogRead(_analogY), yMin, yMax, -512.0, +512.0);
	
	int angle=(int)((atan2((float)yComp, (float)xComp)*180.0)/PI);
	
	return angle;
}

void PerpetualServo::move(int speed)
{
	analogWrite(_motor1, 0);
	analogWrite(_motor1, 0);
	
	if(speed!=0)
	{
		if(speed>0)
		{
			analogWrite(_motor1, (byte)speed);
		}
		else
		{
			analogWrite(_motor2, (byte)speed);
		}
	}
}